Addrinfo#connect_from が Addrinfo オブジェクトを受け付けない

01/05/2012 06:35 PM - ohai (Ippei Obayashi)
Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.0.0dev (2012-01-04 trunk 34210)

[x86_64-linux]

Backport:  

Description

Addrinfo#connect_from (ext/socket/lib/socket.rb) の rdoc には

# Addrinfo object can be taken for the argument.

Addrinfo.tcp("www.ruby-lang.org",

80).connect_from(Addrinfo.tcp("0.0.0.0", 4649)) {|s|

s.print "GET / HTTP/1.0\r\nHost: www.ruby-lang.org\r\n\r\n"

puts s.read

}

とあり、 Addrinfo オブジェクトを受け付けるように書かれていますが、実際には

その内容は無視されてしまいます。以下のようなスクリプトで確認できます。

require 'socket'

Addrinfo.tcp("www.example.com", 80).connect_from(Addrinfo.tcp("0.0.0.0", 49021)) {|s|

p s.local_address.ip_port

s.close

}

原因は Addrinfo#family_addrinfo に Addrinfo オブジェクトを渡した時の返り値が適切でないことです。

添付したパッチでとりあえずは期待通りに動きます。

適当に作った問題再現用テストも添付します。

Associated revisions

Revision 268d1a22 - 01/09/2012 11:11 AM - akr (Akira Tanaka)

ext/socket/lib/socket.rb (family_addrinfo): return the given

addrinfo object.

Patch by Ippei Obayashi.  [ruby-dev:45095] [Bug #5845]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34244 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/09/2012 08:11 PM - akr (Akira Tanaka)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r34244.

Ippei, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

06/11/2025 1/2

http://www.ruby-lang.org%5Cr%5Cn%5Cr%5Cn


ext/socket/lib/socket.rb (family_addrinfo): return the given

addrinfo object.

Patch by Ippei Obayashi.  [ruby-dev:45095] [Bug #5845]

Files

addrinfo_family_addrinfo_fix.patch 722 Bytes 01/05/2012 ohai (Ippei Obayashi)

addrinfo_connect_from_test.patch 836 Bytes 01/05/2012 ohai (Ippei Obayashi)
